# Credits, Notes, and Reference

## Ruby

  + https://apidock.com/rails/String/to_datetime
  + https://stackoverflow.com/a/5905875/670433
  + https://apidock.com/ruby/DateTime/strftime
  + [active model validation requirements too great?](https://stackoverflow.com/questions/37619583/how-to-load-only-activemodel-validations)

## Rubygems

  + http://data-creative.info/reference-docs/2015/07/03/how-to-make-a-ruby-gem/
  + https://guides.rubygems.org/make-your-own-gem/#adding-an-executable
  + https://github.com/rubygems/rubygems/issues/1267#issuecomment-196180872
  + http://data-creative.info/reference-docs/2015/07/03/how-to-make-a-ruby-gem/

### Rake Tasks

  + http://andyatkinson.com/blog/2014/06/23/sharing-rake-tasks-in-gems
  + https://github.com/ruby/rake

## Banner

  + https://myaccess.georgetown.edu

## Google Calendar API

  + https://developers.google.com/calendar/concepts/events-calendars
  + https://developers.google.com/calendar/quickstart/ruby
  + https://developers.google.com/api-client-library/ruby/apis/calendar/v3
  + https://github.com/northworld/google_calendar
  + https://developers.google.com/api-client-library/ruby/auth/installed-app#choosingredirecturi
  + https://developers.google.com/calendar/v3/reference/calendarList/list#examples
  + https://developers.google.com/calendar/v3/reference/calendars/insert
  + https://developers.google.com/calendar/auth
  + https://developers.google.com/calendar/v3/reference/calendars/delete
  + [Auth scope constants](https://github.com/googleapis/google-api-ruby-client/blob/6773823e78266830a9a8a651d5fd52e307b63e97/generated/google/apis/calendar_v3.rb#L31-L43)
  + https://developers.google.com/calendar/v3/reference/events/insert
  + https://developers.google.com/calendar/v3/reference/events/update
  + https://developers.google.com/calendar/v3/reference/events/delete
  + So many events. They don't get deleted, they go into "cancelled" [status](https://developers.google.com/calendar/v3/reference/events#status)
  + https://developers.google.com/calendar/v3/reference/events/list

## Google Sheets and Drive APIs

  + https://developers.google.com/sheets/api/quickstart/ruby
  + https://developers.google.com/sheets/api/guides/migration#list_spreadsheets_for_the_authenticated_user
  + https://developers.google.com/drive/api/v3/reference/files/list
  + https://developers.google.com/drive/api/v3/quickstart/ruby
  + https://stackoverflow.com/questions/37876423/get-the-list-of-all-spreadsheets-associated-with-google-account-using-sheets-api
  + https://github.com/googleapis/google-api-ruby-client/blob/711dfb83b33c03535076917726956584d5c8bf9a/generated/google/apis/drive_v3/service.rb#L795-L847
  + https://github.com/googleapis/google-api-ruby-client/blob/711dfb83b33c03535076917726956584d5c8bf9a/generated/google/apis/sheets_v4/service.rb#L481-L518
  + https://developers.google.com/sheets/api/reference/rest/v4/spreadsheets/create
  + https://developers.google.com/sheets/api/reference/rest/v4/spreadsheets#Spreadsheet
  + https://developers.google.com/sheets/api/reference/rest/v4/spreadsheets/sheets
  + https://stackoverflow.com/questions/43207765/how-do-i-add-data-to-a-google-sheet-from-ruby
  + https://github.com/googleapis/google-api-ruby-client/blob/711dfb83b33c03535076917726956584d5c8bf9a/generated/google/apis/sheets_v4/service.rb#L338-L406
  + https://developers.google.com/sheets/api/reference/rest/v4/spreadsheets.values/append
  + https://github.com/googleapis/google-api-ruby-client/blob/711dfb83b33c03535076917726956584d5c8bf9a/generated/google/apis/drive_v3/service.rb#L604-L639
  + https://developers.google.com/drive/api/v2/reference/files/delete
  + https://stackoverflow.com/questions/46836393/how-do-i-delete-a-spreadsheet-file-using-google-spreadsheets-api

## Parsing HTML with Nokogiri

  + https://www.nokogiri.org/tutorials/searching_a_xml_html_document.html

## Testing and Quality Control

  + https://github.com/bblimke/webmock/wiki/Enabling-and-Disabling-WebMock
  + https://docs.travis-ci.com/user/environment-variables/#default-environment-variables
  + https://relishapp.com/rspec/rspec-core/v/2-4/docs/command-line/tag-option
  + [factory attributes for reserved words](https://github.com/thoughtbot/factory_bot/blob/master/GETTING_STARTED.md#method-name--reserved-word-attributes)

### Code Climate

  + https://docs.codeclimate.com/docs/approve-code-climate-as-a-third-party-application-in-github-1
  + https://docs.codeclimate.com/docs/my-repository-isnt-listed-when-i-try-to-add-it-to-code-climate
  + https://docs.codeclimate.com/docs/finding-your-test-coverage-token#section-regenerating-a-repos-test-reporter-id
  + https://docs.codeclimate.com/docs/configuring-test-coverage
  + https://docs.codeclimate.com/docs/travis-ci-test-coverage

#### Test Coverage Reporting

  + https://github.com/colszowka/simplecov
  + https://github.com/chetan/simplecov-console/
  + https://medium.com/the-code-review/display-your-ruby-test-coverage-using-simplecov-gem-and-codeclimate-6db6336fe409
